
#include "pcecircle.h"

/*
 * pceLCDCircle: ^~`
 * 
 * in  long color FA0: A3: 
 * in  long xc    S X W
 * in  long yc    S Y W
 * in  long r     a
 * ret n/a
 *
 * Reference: FuC ɂŐVASYTv
 *            1991 NAISBN4-87408-414-1, 2400 ~
 *            pp.65uOtBbNXvcircle.c
 *            http://oku.edu.mie-u.ac.jp/~okumura/algo/circle.html
 *            ̃pb`ς݁B
 */
void pceLCDCircle(long color, long xc, long yc, long r)
{
  int x, y;

  x = r;  y = 0;
  while(x >= y)
  {
    pceLCDPoint(color, xc + x, yc + y);
    pceLCDPoint(color, xc + x, yc - y);
    pceLCDPoint(color, xc - x, yc + y);
    pceLCDPoint(color, xc - x, yc - y);
    pceLCDPoint(color, xc + y, yc + x);
    pceLCDPoint(color, xc + y, yc - x);
    pceLCDPoint(color, xc - y, yc + x);
    pceLCDPoint(color, xc - y, yc - x);
    if((r -= (y++ << 1) + 1) <= 0)
      r += --x << 1;
  }
}
