
#include "pcecircle.h"

/*
 * pceLCDEllipse: ȉ~`
 * 
 * in  long color FA0: A3: 
 * in  long xc    S X W
 * in  long yc    S Y W
 * in  long rx    X ̔a
 * in  long ry    Y ̔a
 * ret n/a
 *
 * Reference: FuC ɂŐVASYTv
 *            1991 NAISBN4-87408-414-1, 2400 ~
 *            pp.65-66uOtBbNXvellipse.c
 *            http://oku.edu.mie-u.ac.jp/~okumura/algo/circle.html
 *            ̃pb`ς݁B
 */
void pceLCDEllipse(long color, long xc, long yc, long rx, long ry)
{
  int x, x1, y, y1, r;

  if(rx > ry)
  {
    x = r = rx;  y = 0;
    while(x >= y)
    {
      x1 = x * ry / rx;
      y1 = y * ry / rx;
      pceLCDPoint(color, xc + x, yc + y1);
      pceLCDPoint(color, xc + x, yc - y1);
      pceLCDPoint(color, xc - x, yc + y1);
      pceLCDPoint(color, xc - x, yc - y1);
      pceLCDPoint(color, xc + y, yc + x1);
      pceLCDPoint(color, xc + y, yc - x1);
      pceLCDPoint(color, xc - y, yc + x1);
      pceLCDPoint(color, xc - y, yc - x1);
      if((r -= (y++ << 1) + 1) <= 0)
        r += --x << 1;
    }
  }
  else
  {
    x = r = ry;  y = 0;
    while(x >= y)
    {
      x1 = x * rx / ry;
      y1 = y * rx / ry;
      pceLCDPoint(color, xc + x1, yc + y);
      pceLCDPoint(color, xc + x1, yc - y);
      pceLCDPoint(color, xc - x1, yc + y);
      pceLCDPoint(color, xc - x1, yc - y);
      pceLCDPoint(color, xc + y1, yc + x);
      pceLCDPoint(color, xc + y1, yc - x);
      pceLCDPoint(color, xc - y1, yc + x);
      pceLCDPoint(color, xc - y1, yc - x);
      if((r -= (y++ << 1) + 1) <= 0)
        r += --x << 1;
    }
  }
}
