
#if !defined(PCECIRCLE_H)
#define PCECIRCLE_H

#include <piece.h>

/*
 * pceLCDCircle: ^~`
 * 
 * in  long color FA0: A3: 
 * in  long xc    S X W
 * in  long yc    S Y W
 * in  long r     a
 * ret n/a
 *
 * Reference: FuC ɂŐVASYTv
 *            1991 NAISBN4-87408-414-1, 2400 ~
 *            pp.65uOtBbNXvcircle.c
 *            http://oku.edu.mie-u.ac.jp/~okumura/algo/circle.html
 *            ̃pb`ς݁B
 */
void pceLCDCircle(long color, long xc, long yc, long r);

/*
 * pceLCDEllipse: ȉ~`
 * 
 * in  long color FA0: A3: 
 * in  long xc    S X W
 * in  long yc    S Y W
 * in  long rx    X ̔a
 * in  long ry    Y ̔a
 * ret n/a
 *
 * Reference: FuC ɂŐVASYTv
 *            1991 NAISBN4-87408-414-1, 2400 ~
 *            pp.65-66uOtBbNXvellipse.c
 *            http://oku.edu.mie-u.ac.jp/~okumura/algo/circle.html
 *            ̃pb`ς݁B
 */
void pceLCDEllipse(long color, long xc, long yc, long rx, long ry);

#endif
